/**
 * 
 * 法器升级或者转换入口
 */

const { ccclass, property } = cc._decorator



@ccclass
export default class WeaponUpPanel extends cc.Component {
    protected static __CUSTOM_NAME:string = "WeaponUpPanel";
    protected get __CUSTOM_NAME():string{
        return WeaponUpPanel.__CUSTOM_NAME;
    }
    
    @property(cc.Node) attriTemplate: cc.Node = null;
    @property(cc.Node) n_cur: cc.Node = null;
    @property(cc.Node) n_after: cc.Node = null;

    private isLock:boolean = false;

    onLoad(){
        this.attriTemplate.active = false;
    }


    start(){
        this.updateUICustom();
    }

    private updateUICustom(){
        let curAttri = this.n_cur.getChildByName("n_attri");
        curAttri.destroyAllChildren();

        let attrInstance = this.createAttriInstance("攻击",Math.floor( Math.random() * 100 ) );
        curAttri.addChild(attrInstance);

        let afterAttri = this.n_after.getChildByName("n_attri");
        afterAttri.destroyAllChildren();
        let attrInstance_after = this.createAttriInstance("生命",Math.floor( Math.random() * 100 ));
        afterAttri.addChild(attrInstance_after);
    }



    private createAttriInstance(attriKey:string,attriVlaue:number,color?:cc.Color):cc.Node{
        let attrInstance = cc.instantiate(this.attriTemplate);
        attrInstance.active = true;
        attrInstance.position = cc.Vec2.ZERO;
        let attrKey_lb = attrInstance.getChildByName("attrKey").getComponent(cc.Label);
        let attrValue_lb = attrInstance.getChildByName("attrValue").getComponent(cc.Label);
        attrKey_lb.string = attriKey;
        attrValue_lb.string = attriVlaue.toString();
        return attrInstance;
    }

    onLockToggleGroupClick(toggle, customEventData):void{
        this.isLock = toggle.isChecked;
        this.updateUICustom();
    }

}